/*!
 * @file ItemTrait.h
 * @brief ゲーム中のアイテム特性のプロトタイプ定義
 * @date 2013/12/22
 * @author Deskull
 * 2013 Sikabane Works.
 */

#include "stdafx.h"
#include "GameElement.h"

namespace Deeangband
{

	/*!
	 * @class ItemTrait
	 * @brief アイテム特性のクラス
	 */
	class ItemTrait : public GameElement
	{

	private:

		friend class boost::serialization::access;

		/*!
		 * @brief クラスのシリアライズを設定する
		 * @param archive アーカイブ化するクラスのアドレス
		 * @param version ファイルバージョン
		 * @return XMLSerializeテンプレート
		 */
		template<class Archive> void serialize(Archive &archive, const unsigned int version) 
		{
			if(version >= 0)
			{
				archive & boost::serialization::make_nvp("Name", name);
			}
		}

	public:

		/*! 
		* @brief ItemTraitクラスコンストラクタ
		*/
		ItemTrait::ItemTrait(void);

		/*! 
		* @brief ItemTraitクラスデストラクタ
		*/
		ItemTrait::~ItemTrait(void);

		/*! 
		* @brief ItemTraitクラスのデータ消去
		*/
		void ItemTrait::WipeData(void);

	};

}